dccifd(8)

NAME
dccifd - Distributed Checksum Clearinghouse Interface Daemon

SYNOPSIS
dccifd [-VdbxANQ] [-G on | off | noIP | IPmask/xx] [-h homedir] [-I user] [-p /sock | lhost,lport,rhost] [-o /sock | host,port]
[-D local-domain] [-m map] [-w whiteclnt] [-U userdirs]
[-a IGNORE | REJECT | DISCARD] [ -t type, [log-thold,] rej-thold]
[ -g [not-] type] [-S header] [-l logdir] [-R rundir] [-r rejection-msg] [-T tmpdir] [-j maxjobs]
[-B dnsbl-option] [-L ltype,facility.level]

DESCRIPTION

dccifd is a daemon intended to connect spam filters such as SpamAssasin and mail transfer agents (MTAs) other than sendmail to DCC servers. The MTA or filter dccifd which in turn reports related checksums to the nearest DCC server and adds an X-DCC SMTP header line to the message. The MTA is told to reject the message if it is unsolicited bulk.

Dccifd is similar to the DCC sendmail milter interface, dccm(8) and the DCC Procmail interface, dccproc(8). Dccifd is more efficient than dccproc(8) but not restricted to use with sendmail like dccm(8). All three send reports of checksums related to mail received by DCC clients and queries about the total number of reports of particular checksums.

MTA programs use a simple ASCII protocol a subset of SMTP to send a mail message including its SMTP envelope to the daemon. Dccifd responds with an indication of whether the message is unsolicited bulk and an optional copy of the message with an X-DCC header added. The ASCII protocol is described below and in the include/dccif.h file in the DCC source. There is a sample C interface routine in the dcclib/dccif.c file in the DCC source and the dcclib.a library generated from the source. A Perl version of the interface routine is in dccifd/dccif.pl. Test or demonstration programs in the style of dccproc(8) that use those interface routines are in /var/dcc/build/dcc/dccifd/dccif-test.

A subset of ESMTP can be used instead of the ASCII protocol to connect dccifd to postfix as a "Before-Queue Content Filter." See the -o flag.

Since the checksums of messages that are whitelisted locally by the -w whiteclnt file are not reported to the DCC server, dccifd knows nothing about the total recipient counts for their checksums and so cannot add X-DCC header lines to such messages.

Enable the daemon and put its parameters in the /var/dcc/dcc_conf file and start the daemon with the /opt/local/libexec/rcDCC or /opt/local/libexec/start-dccifd scripts.

The list of servers that dccifd contacts is in the memory mapped file /var/dcc/map shared by local DCC clients. The file is maintained with cdcc(8).

  OPTIONS
The following options are available:

-V  displays the version of dccifd.

-d  enables debugging output from the DCC client software. Additional -d options increase the number of messages. A single -d logs aborted SMTP transactions including those from some "dictionary attacks."

-b  causes the daemon to not detach itself from the controlling tty and put itself into the background.

-x  causes the daemon to try "extra hard" to contact a DCC server. Since it is usually more important to deliver mail than to report its checksums, dccifd normally does not delay too long while trying to contact a DCC server. It will not try again for several seconds after a failure. With -x, it will always try to contact the DCC server and it will tell the MTA to answer the DATA command with a 4yz temporary failure.

-A  adds to existing X-DCC headers in the message instead of replacing existing headers of the brand of the current server.

-N  neither adds, deletes, nor replaces existing X-DCC headers in the message. Each message is logged, rejected, and otherwise handled the same.

-Q  only queries the DCC server about the checksums of messages instead of reporting and querying. This is useful when dccifd is used to filter mail that has already been reported to a DCC server by another DCC client. No single mail message should be reported to a DCC server more than once per recipient, because each report will increase the apparent "bulkness" of the message.

    It is better to use MXDCC lines in the global /var/dcc/whiteclnt file for your MX mail servers that use DCC than to use -Q with dccifd.

-G on | off | noIP | IPmask/xx
    controls greylisting. At least one working greylist server must be listed in the /var/dcc/map file. If more than one is named, they must "flood" or change checksums and they must use the same -G parameters. See dccd(8). Usually all dccm or dccifd DCC client processes use the same -G parameters.

    IPmask/xx and noIP remove part or all of the IP address from the greylist triple.

-h homedir
    overrides the default DCC home directory, /var/dcc.

-I user
    specifies the UID and GID of the process.

-p /sock/name | lhost,lport,rhost
    overrides the default address at which programs contact dccifd. The default is a UNIX domain socket named dccifd in the DCC home directory.

    The second form specifies a local host name or IP address, a local TCP port number, and the host name or IP addresses of computers that can use dccifd. 127.0.0.1 is a common choices for lhost. The string @ specifies IN_ADDRANY or all local IP addresses. 127.0.0.1 is a common choice for rhost, but it can be a xxx.xxx.xxx.xxx/mm CIDR block or a xxx.xxx.xxx.xxx-yyy.yyy.yyy.yyy range of IPv4 or IPv6 addresses.

-o /sock | host,port
    enables SMTP proxy mode instead of the ASCII protocol and specifies the output connection when dccifd acts as an SMTP proxy. It is the address of the SMTP server for which dccifd acts as SMTP client. When /sock is /dev/null, dccifd acts as if there were downstream SMTP server that always answers "250 ok". The string @ specifies the same IP address as the incoming TCP connection.

    The input to dccifd in SMTP proxy mode is specified with --p. For example, -p 127.0.0.1,10025,127.0.0.1/32 -o 127.0.0.1,10026 could be used to connect dccifd with Postfix as described in the documentation in version 2.2.1 Postfix documentation.

    See below concerning the subset of ESMTP used in this mode.

-m map
    specifies a name or path of the memory mapped parameter file instead of the default /var/dcc/map. It should be created with the cdcc(8) command.

-w whiteclnt
    specifies an optional file containing filtering parameters as well as SMTP client IP addresses, SMTP envelope values, and header values of mail that is spam or is not spam and does not need a X-DCC header, and whose checksums should not be reported to the DCC server.

    If the pathname whiteclnt is not absolute, it is relative to the DCC home directory.

    The format of the dccifd whiteclnt file is the same as the /var/dcc/whitelist files used by dbclean(8) and the whiteclnt file used by dccproc(8). See dcc(8) for a description of DCC white and blacklists. Because the contents of the whiteclnt file are used frequently, a companion file is automatically created and maintained. It has the same pathname but with an added suffix of .dccw and contains a memory mapped hash table of the main file.

    A whitelist entry ("OK") or two or more semi-whitelistings ("OK2") for one of the message's checksums prevents all of the message's checksums from being reported to the DCC server and the addition of a X-DCC header line by dccifd. A whitelist entry for a checksum also prevents rejecting or discarding the message based on DCC recipient counts as specified by -a and -t. Otherwise, one or more checksums with blacklisting entries ("MANY") cause all of the message's checksums to be reported to the server with an addressee count of "MANY".

    If the message has a single recipient, an env_To whiteclnt entry of "OK" for the checksum of its recipient address acts like any other whiteclnt entry of "OK." When the SMTP message has more than one recipient, the effects can be complicated. When a message has several recipients with some but not all listed in the whiteclnt file, dccifd tries comply with the wishes of the users who want filtering as well as those who don't by silently not delivering the message to those who want filtering (i.e. are not whitelisted) and delivering the message to users who don't want filtering.

-U userdirs
    enables per-user whiteclnt files and log directories. Each target of a message can have a directory of log files named userdirs/addr/log where addr is the local user or mailbox name computed by the MTA. The name of each user's log directory must be log. If it is not absolute, userdirs is relative to the DCC home directory. The directory containing the log files must be named log and it must be writable by the dccifd process. Each log directory must exist or logging for the corresponding is silently disabled. The files created in the log directory are owned by the UID of the dccifd process, but they have group and other read and write permissions copied from the corresponding log directory. To ensure the privacy of mail, it may be good to make the directories readable only by owner and group, and to use a cron script that changes the owner of each file to match the grandparent addr directory.

    There can also be a per -user whitelist file named userdirs/addr/whiteclnt for each address addr. Any checksum that is not white- or blacklisted by an individual addressee's per-user whiteclnt file is checked in the main /var/dcc/whiteclnt file. A missing per-addressee whiteclnt file is the same as an empty file. Relative paths for files included in per-addressee files are resolved in the DCC home directory. The whiteclnt files and the addr directories containing them must be writable by the dccifd process.

    Option lines in per-user whiteclnt files can be used to modify many aspects of dccifd filtering, as described in the main dcc man page. For example, an option dcc-off line turns off DCC filtering for individual mailboxes.

-a IGNORE | REJECT | DISCARD
    specifies the action taken when dccifd is in proxy mode with -o and DCC server counts or -t thresholds say that a message is unsolicited and bulk. IGNORE causes the message to be unaffected except for adding the X-DCC header line to the message. This turns off all filtering except greylisting.

    Spam can also be REJECTed or when in proxy mode with -o accepted and silently DISCARDed without being delivered to local mailboxes. The default is REJECT.

    Mail forwarded via IP addresses marked MX or MXDCC in the main /var/dcc/whiteclnt file is treated as if -a DISCARD were specified. This prevents "bouncing" spam.

    The effects of the -w whiteclnt are not affected by -a.

-t  type, [log-thold,] rej-thold sets logging and "spam" thresholds for checksum type. The checksum types are IP, env_From, From, Message-ID, substitute, Received, Body, Fuz1, Fuz2, rep-total, and rep. The first six, IP through substitute, have no effect except when a local DCC server configured with -K is used. The substitute thresholds apply to the first substitute heading encountered in the mail message. The string ALL sets thresholds for all types, but is unlikely to be useful except for setting logging thresholds. The string CMN specifies the commonly used checksums Body, Fuz1, and Fuz2. Rej-thold and log-thold must be numbers, the string NEVER, or the string MANY indicating millions of targets. Counts from the DCC server as large as the threshold for any single type are taken as sufficient evidence that the message should be logged or rejected.

    Log-thold is the threshold at which messages are logged. It can be handy to log messages at a lower threshold to find solicited bulk mail sources such as mailing lists. If no logging threshold is set, only rejected mail and messages with complicated combinations of white and blacklisting are logged. Messages that reach at least one of their rejection thresholds are logged regardless of logging thresholds.

    Rej-thold is the threshold at which messages are considered "bulk," and so should be rejected or discarded if not whitelisted.

    DCC Reputation thresholds in the commercial version of DCC are controlled by thresholds on checksum types rep and rep-total. The DCC Reputations of IP addresses that the DCC database says have sent more than rep-total,log-thold are computed and messages from those addresses are logged. Messages from IP addresses with DCC Reputations of at least the rep,rej-thold rejection threshold can be rejected. The DCC Reputation of an IP address is the percentage of its messages known to have been sent to at least 10 recipients. The defaults are equivalent to rep,never and rep-total,never,20.

    Bulk DCC Reputations do not reject mail unless enabled by an option DCC-rep-on line a whiteclnt file.

    The checksums of locally whitelisted messages are not checked with the DCC server and so only the number of targets of the current copy of a whitelisted message are compared against the thresholds.

    The default is ALL,NEVER, so that nothing is discarded, rejected, or logged. A common choice is CMN,25,50 to reject or discard mail with common bodies except as overridden by the whitelist of the DCC server, the sendmail ${dcc_isspam} and ${dcc_notspam} macros, and -g, and -w.

-g  [not-] type indicates that whitelisted, OK or OK2, counts from the DCC server for a type of checksum are to be believed. They should be ignored if prefixed with not-. Type is one of the same set of strings as for -t. Only IP, env_From, and From are likely choices. By default all three are honored, and hence the need for not-.

-S hdr
    adds to the list of substitute or locally chosen headers that are checked with the -w whiteclnt file and sent to the DCC server. The checksum of the last header of type hdr found in the message is checked. Hdr can be HELO to specify the SMTP envelope HELO value. Hdr can also be mail_host to specify the host name from the Mail_from value in the SMTP envelope. As many as six different substitute headers can be specified, but only the checksum of the first of the six will be sent to the DCC server.

-l logdir
    specifies a directory in which files containing copies of messages processed by dccifd are kept. They can be copied to per-user directories specified with -U. Information about other recipients of a message is deleted from the per-user copies.

    See the FILES section below concerning the contents of the files. See also the option log-subdirectory-{day,hour,minute} lines in /var/dcc/whiteclnt files described in dcc(8).

    The directory is relative to the DCC home directory if it is not absolute

-R rundir
    specifies the "run" directory where the file containing the daemon's process ID is stored. The default value is /var/run/dcc.

-T tmpdir
    changes the default directory for temporary files from the default. The default is the directory specified with -l or the system default if -l is not used. The system default is often /tmp.

-D local-domain
    specifies a host or domain name by which the system is known. There can be several -D settings.

    To find the per-user log directory and whitelist for each mail recipient, dccifd must know each recipient's user name. The ASCII protocol used between and the MTA includes an optional user name with each SMTP recipient address. When the user name is absent when the ASCII protocol is used or when the subset of ESMTP enabled with -o is used, and when the SMTP recipient address includes an at sign (@) each mail address is checked against the list of local-domains. The part of the recipient address remaining after longest matching local-domain (if any) is taken as the user name. The match is anchored at the right or the end of the recipient address. It must start at a period (.) or at sign (@) in the domain name part of the address.

    If local-domain starts with an asterisk (*) indicating a wildcard, preceding sub-domain names are discarded to compute the user name. Otherwise, the computed user name will include any unmatched sub-domain names.

    The default value of local-domain when there are no -D settings is the host name of the system.

-r rejection-msg
    specifies the rejection message in -o proxy mode for unsolicited bulk mail or for mail temporarily blocked by greylisting when -G is specified. The first -r rejection-msg replaces the default bulk mail rejection message, "5.7.1 550 mail %ID from %CIP rejected by DCC". The second replaces "4.2.1 452 mail %ID from %CIP temporary greylist embargoed". The third -r rejection-msg replaces the default SMTP rejection message "5.7.1 550 %ID bad reputation; see http://commercial-dcc.rhyolite.com/cgi-bin/reps.cgi?tgt=%CIP" for mail with bulk DCC Reputations. If rejection-msg is the zero-length string, the -r setting is counted but the corresponding message is not changed.

    Rejection-msg can contain specific information about the mail message. The following strings starting with % are replaced with the corresponding values:
    %ID message ID such as the unique part of log file name or sendmail queue ID
    %CIP
        SMTP client IP address
    %BTYPE
        type of DNS blacklist hit, such as "SMTP client", "mail_host", or "URL NS"
    %BTGT
        IP address or name declared bad by DNS blacklist
    %BPROBE
        domain name found in DNS blacklist such as 4.3.2.10.example.com
    %BRESULT
        value of the %BPROBE domain name found in DNS blacklist

    A common alternate for the bulk mail rejection message is "4.7.1 451 Access denied by DCC" to tell the sending mail system to continue trying. Use a 4yz response with caution, because it is likely to delay for days a delivery failure message for false positives. If the rejection message does not start with an RFC 1893 status code and RFC 2821 reply code, 5.7.1 and 550 or 4.2.1 and 452 are used.

    See also -B set:rej-msg=rejection-msg to set the status message for mail rejected by DNS blacklists.

-j maxjobs
    limits the number of simultaneous requests that will be processed. The default value is the maximum number that seems to be possible given system limits on open files, select() bit masks, and so forth. Start dccifd with -d and see the starting message in the system log to see the limit.

-B dnsbl-option
    enables DNS blacklist checks of the SMTP client IP address, SMTP envelope Mail_From sender domain name, and of host names in URLs in the message body. Body URL blacklisting has too many false positives to use on abuse mailboxes. It is less effective than greylisting with dccm(8) or dccifd(8) but can be useful in situations where greylisting cannot be used.

    Dnsbl-option is either one of the -B set:option forms or
        -B
        domain[any[,bltype]]

        -B
        domain[,IPaddr
        [/xx[,bltype]]]

        -B
        domain[,IPaddr
        [-IPaddrHI[,bltype]]]

    Domain is a DNS blacklist domain such as example.com that will be searched. The string any, IPaddr, IPaddr/xxx, or IPaddrLO-IPaddrHI, specifies which IP addresses found in the DNS blacklist say that mail messages should be rejected "127.0.0.2" is assumed if no address(es) are specified. IPv6 addresses can be specified with the usual colon (:) notation. Host names can be used instead of numeric addresses. The type of DNS blacklist is specified by bltype as name, all-names, IPv4, or IPv6. Given an envelope sender domain name or a domain name in a URL of spam.domain.org and a blacklist of type name, spam.domain.org.example.com will be looked up. The names spam.domain.org.example.com, domain.org.example.com, and org.example.com will be looked up in blacklists of type all-names. Use name with DNS blacklists that use wild cards for speed but all-names for other DNS name blacklists. Blacklist types of IPv4 and IPv6 require that the domain name in a URL sender address be resolved into an IPv4 or IPv6 address. The resolved address from the mail message is then written as a reversed string of decimal octets to check the DNS blacklist, as in 2.0.0.127.example.com.

    More than one blacklist can be specified and blacklists can be grouped with -B set:group=X. All searching within a group of blacklists is stopped at the first positive result.

    Positive results are ignored after being logged unless an option DNSBL-on line appears a whiteclnt file.

    -B set:no-client
        implies that SMTP client IP addresses and reverse DNS domain names should not be checked in the following blacklists.
        -B set:client restores the default for the following blacklists.

    -B set:no-mail_host
        implies that SMTP envelope Mail_From sender domain names should not be checked in the following blacklists. -B set:mail_host restores the default.

    -B set:no-URL
        says that URLs in the message body should not be checked in the in the following blacklists. -B set:URL restores the default.

    -B set:no-MX
        says MX servers of sender Mail_From domain names and host names in URLs should not be checked in the following blacklists.
        -B set:MX restores the default.

    -B set:no-NS
        says DNS servers of sender Mail_From domain names and host names in URLs should not be checked in the following blacklists. -B set:NS restores the default.

    -B set:defaults
        is equivalent to all of -B set:client
        -B set:mail_host -B set:URL -B set:MX and -B set:NS

    -B set:group=X
        adds following DNS blacklists specified with
            -B
            domain[,IPaddr
            [/xx[,bltype]]]

        to group 1, 2, or 3.

    -B set:debug=X
        sets the DNS blacklist logging level

    -B set:msg-secs=S
        limits dccifd to S seconds total for checking all DNS blacklists. The default is 25.

    -B set:URL-secs=S
        limits dccifd to at most S seconds resolving and checking any single URL. The default is 11. Some spam contains dozens of URLs and some "spamvertised" URLs contain host names that need minutes to resolve. Busy mail systems cannot afford to spend minutes checking each incoming mail message.

    -B set:rej-msg=rejection-msg
        sets the SMTP rejection message for the following blacklists. Rejection-msg must be in the same format as for -r. If rejection-msg is null, the default is restored. The default DNS blacklist rejection message is the first message set with -r.

    -B set:maxjobs=X
        sets maximum number of helper processes to X. In order to use typical single-threaded DNS resolver libraries, dccifd uses fleets of helper processes. It is rarely a good idea to change the default, which is the same as the maximum number of simultaneous jobs set with -j.

    -B set:progpath=/opt/local/libexec/dns-helper
        changes the path to the helper program.

-L ltype,facility.level
    specifies how messages should be logged. Ltype must be error, info, or off to indicate which of the two types of messages are being controlled or to turn off all syslog(3) messages from dccifd. Level must be a syslog(3) level among EMERG, ALERT, CRIT, ERR, WARNING, NOTICE, INFO, and DEBUG. Facility must be among AUTH, AUTHPRIV, CRON, DAEMON, FTP, KERN, LPR, MAIL, NEWS, USER, UUCP, and LOCAL0 through LOCAL7. The default is equivalent to
        -L info,MAIL.NOTICE -L error,MAIL.ERR

dccifd normally sends counts of mail rejected and so forth to the system log at midnight. The SIGUSR1 signal sends an immediate report to the system log. The reports will be repeated every 24 hours at the same minute as the signal instead of at midnight.

  Protocol
Dccifd uses a simple ASCII protocol to receive mail messages to be checked and to return results. For each message, the MTA must open a connection to the interface daemon, send options, envelope recipients, and the message, receive the results, and close the connection.

Instead of the ASCII protocol, a subset of ESMTP is enabled by -o. Only the familiar HELO, EHLO, Mail, Rcpt, DATA, RSET, and QUIT commands and the Postfix extensions XFORWARD and XCLIENT are honored. Since SMTP has no provisions for user names, the protocol enabled by -o depends on a list of local domain names specified with -D to find per-user log directories and whitelist files. If neither XFORWARD nor XCLIENT are used, dccifd uses the IP address of the MTA and the value of the HELO command.

In the ASCII protocol, each of the following lines are sent in order to dccifd. Each ends with a newline ('\n') character.
options
    zero or more blank-separated strings among:
    spam
        the message is already known to be spam
    body
        return all of the headers with the added X-DCC header line and the body
    header
        return the X-DCC header
    cksums
        return X-DCC header and the checksums for the message.
    query
        ask the DCC server about the message without reporting it, as if dccifd were running with -Q.
    no-grey
        disable greylisting for this message.
    grey-query
        only query the greylist server for this message. -G on must be in use.
    log ensure that this message is logged as if dccifd were running with -t -all,0,
client
    IP address of the SMTP client in a "dotted" or "coloned" ASCII string and reverse-DNS host name. If the host name is present, it must follow a carriage return character ('\r') after the IP address. The client IP address must be present and non-null if the host name is present. The string "0.0.0.0\n" is understood the same as the null string, meaning that both the IP address and host name are absent. If the client IP address is absent, then the IP address and host name are taken from the first non-local Received header if it has the standard "name (name [IP address])..." format. Non-standard Received headers commonly added by qmail as well as Received headers specifying IP addresses marked MX or MXDCC in the global -w whiteclnt file are skipped.
HELO
    SMTP HELO value or nothing, followed by a newline ('\n') character. If the HELO value is null and the IP address of the SMTP client are not supplied, they will be taken from the same Received: header that supplies the IP address.
sender
    or SMTP Mail From command value for the env_from checksum. If the sender is null, the contents of the first Return-Path: or UNIX style From_ header is used.
recipients
    or SMTP Rcpt To recipient mailboxes followed by corresponding local user names, one (mailbox,user) pair to a line. Each optional local user name is separated from the corresponding mailbox recipient address by a carriage return ('\r'). A local user name can be null if it is not known, but each recipient mailbox must be non-null. If there are no lines of (mailbox,user) pairs and if the spam option is not included, then the query is assumed. Mailboxes without user names will lack per-user log files and cannot invoke a per-user whiteclnt file.

The last recipient-user name pair is followed by an empty line and the headers and body of the message. The end of the body of the mail message is signaled by the MTA half-closing the connection. See shutdown(2).

Dccifd responds with three things. First is a one character line of the overall result advising the MTA:
A   accept the message for all recipients and answer the SMTP DATA command with a 2yz result.
G   answer with a 4yz result to embargo the message for greylisting.
R   reject the message and answer the DATA command with a 5yz result.
S   accept the message for some recipients and so answer the DATA command with a 2yz result.
T   temporary failure by the DCC system and so answer with a 4yz result.

Second is a line of characters indicating the disposition of the message for each corresponding recipient:
A   deliver the message
G   discard the message during a greylist embargo
R   discard the message as spam
The SMTP protocol allows only a single result for the DATA command for all recipients that were not rejected before body of the message was offered with the DATA command. To accept the message for some recipients and reject it for others, the MTA must tell the SMTP client it is accepting the message for all recipients and then discard it for those that would reject it.

Finally, if the body or header strings are in the first line of options sent by the MTA to the daemon, then the X-DCC header line or the entire body with the X-DCC header line follows.

FILES
/var/dcc
    is the DCC home directory in which other files are found.
/opt/local/libexec/start-dccifd
    or
/opt/local/libexec/rcDCC
    are scripts used to start the daemon.
dcc_conf
    contains parameters used by the scripts to start DCC daemons and cron jobs.
logdir
    is an optional directory specified with -l and containing marked mail. Each file in the directory contains one message, at least one of whose checksums reached its -t thresholds or that is interesting for some other reason. Each file starts with lines containing the date when the message was received, the IP address of the SMTP client, and SMTP envelope values. Those lines are followed by the body of the SMTP message including its header as it was received. Only approximately the first 32 KBytes of the body are recorded unless modified by ./configure --with-max-log-size=xx The checksums for the message follow the body. They are followed by lines indicate that one of the checksums is white- or blacklisted by the -w whiteclnt file. Each log file ends with the X-DCC header line added to the message and the disposition of the message.
map is the memory mapped file of information concerning DCC servers in the DCC home directory.
whiteclnt
    contains the client whitelist in the format described in dcc(8).
whiteclnt.dccw
    is a memory mapped hash table of the /var/dcc/whiteclnt file.
dccifd.pid
    in the -R rundir directory contains daemon's process ID.

EXAMPLES
Dccifd can be used as Postfix Before-Queue Content filter. In some tests these values for -p and -o in /var/dcc/dcc_conf.

    DCCIFD_ENABLE=on
    DCCIFD_ARGS="-p 127.0.0.1,10025,127.0.0.1/32 -o 127.0.0.1,10026   ..."

worked with these lines in /etc/postfix/master.cf

    smtp      inet  n       -       n       -       -       smtpd
        -o smtpd_proxy_filter=127.0.0.1:10025
    127.0.0.1:10026 inet n  -       n       -	-	smtpd
        -o smtpd_authorized_xforward_hosts=127.0.0.0/8
        -o smtpd_client_restrictions=
        -o smtpd_helo_restrictions=
        -o smtpd_sender_restrictions=
        -o smtpd_recipient_restrictions=permit_mynetworks,reject
        -o smtpd_data_restrictions=
        -o mynetworks=127.0.0.0/8
        -o receive_override_options=no_unknown_recipient_checks

SEE ALSO
cdcc(8), dbclean(8), dcc(8), dccd(8), dblist(8), dccm(8), dccproc(8), dccsight(8),

HISTORY
Implementation of dccifd Distributed Checksum Clearinghouses are based on an idea of Paul Vixie with code designed and written at Rhyolite Software starting in 2000. was started at Rhyolite Software in 2002. This document describes version 1.3.123.

BUGS
dccifd uses -t where dccproc(8) uses -c.

By default dccifd look for its UNIX domain socket in the DCC home directory, but dccm(8) looks in its -R rundir.

Systems without setrlimit(2) and getrlimit(2) RLIMIT_NOFILE can have problems with the default limit on the number of simultaneous jobs, the value of -j. Every job requires four open files. These problems are usually seen with errors messages that say something like
    dccifd[24448]: DCC: accept(): Result too large
A fix is to use a smaller value for -j or to allow dccifd to open more files.